// animated_mesh.h

#ifndef ANIMATED_MESH_H
#define ANIMATED_MESH_H

#include <vector>
#include <string>

#define GLEW_STATIC 1
#include <GL/glew.h>
#include <GL/glut.h>

//#include "vec2.h"
//#include "vec3.h"
//#include "quaternion2.h"

#include <v3.hpp>
#include <quaternion.hpp>

//////////////////////////////////////////////////////////////////////////////////////
struct AnimatedVertex
{
  struct Part
    {
      unsigned bone;
      float    weight;
      cpe::v3     position;
    };
  Part parts[4];
};

//////////////////////////////////////////////////////////////////////////////////////
class AnimatedMesh
{
  GLint weight0_index;
  GLint weight1_index;
  GLint weight2_index;
  GLint weight3_index;
  GLint bones_index;

  GLuint program;
  GLuint vbo_weights;
  GLuint vbo_bones;
  GLuint vbo_textures;
  GLuint vbo_indices;
  std::vector<AnimatedVertex> vertices;
  std::vector<GLuint>         indices;
  std::vector<GLfloat>        tex_coords;
  std::vector<GLfloat>        vertex_attrib0123;
  std::vector<GLfloat>        vertex_attrib4;
public:
  void load (const std::string        &filename);
  void draw (const std::vector<cpe::v3> &skel_pos, const std::vector<cpe::quaternion> &skel_orient, bool update);
  void draw_cpu (const std::vector<cpe::v3> &skel_pos, const std::vector<cpe::quaternion> &skel_orient, bool update);

  void setup_shader(const std::string& vertex_shader,const std::string& fragment_shader);
};

#endif
